module Notebook
  # Public: class to define a note. 
  class Note
      
    # Public: Initialize a Note.
    #
    # title - The String title of the Note.
    # body  - The String body of the Note.
    def initialize(title, body)
      @title  = title
      @body   = body
    end
    
    # Public: Gets/Sets the String title and body of the Note.
    attr_accessor :title, :body
    
    # Public: Generate String version of Note.
    #
    # Returns the String version of the Note.
    def to_s
      "#{title},#{body}"
    end 

    # Public: Write Note to file.
    #
    # Returns nothing.
    def write_to_file(file)
      File.open(file, 'a+') { |f| f.puts(self) }
    end

    def edit
      puts "Current title is: #{title}; enter new title or enter to keep"
      new_title = gets.chomp
      if (new_title != "") 
        @title = new_title
      end
      puts "Current body is: #{body}; enter new body or enter to keep"
      new_body = gets.chomp
      if (new_body != "") 
        @body = new_body
      end
      return self
    end

    def mark_as_done
      @title = "DONE " + @title
      return self
    end

    def edit_title(title)
      @title = title
      return self
    end

  end
end

