require 'singleton'

module Notebook
  class NoteStore
    # http://dalibornasevic.com/posts/9-ruby-singleton-pattern-again
    include Singleton

    attr_accessor :notebook_array

    def initialize
      @notebook_array = Array.new
    end 

    def add(note)
      @notebook_array << note
    end

    def edit(number)
      new_note = @notebook_array[number].edit
      @notebook_array[number] = new_note
      #self.output
    end

    def do_to_all
      #i = 0;  
      #while @notebook_array[i]  
      #  new_note = yield @notebook_array[i]  
      #  @notebook_array[i] = new_note
      #  i += 1  
      #end  
      @notebook_array.each do |i|
        new_note = yield i  
        i = new_note
      end
    end  

    def delete(number)
      @notebook_array.delete_at(number)
    end

    def output
      @notebook_array.each_with_index { |val, index| puts "#{index}: #{val}" }
    end
            
  end
end
