module Notebook
  # Public: class to read back notes from a file
  class Reader

    DEFAULT_NOTEBOOK = "notebook.txt"

    # Public: initialize the reader
    #
    # file - The String name of the file to read in from
    def initialize(file = DEFAULT_NOTEBOOK)
      @file = file
    end

    # Public: read back from the notebook file
    #
    # Returns nothing
    def read
      File.open(@file, 'a+') do |f|
        while line = f.gets do
          note = line.split(',')
          if note.length != 2
            puts "There is a problem!"
            next
          end
          NoteStore.instance.add(Note.new(note.first, note.last))
        end
      end
      #puts "About to output..."
      NoteStore.instance.output
    end
    
    def write_all
      File.open(@file, 'w') do |f|
        NoteStore.instance.notebook_array.each { |x| f.puts(x) }
      end
    end

    def total_notes_string
      total_notes = NoteStore.instance.notebook_array.length
      "Total notes: #{total_notes}"
    end

  end
end



