require_relative 'note'
require_relative 'reader'
require_relative 'options'
require_relative 'notestore'

module Notebook
  class Runner
    attr_reader :options

    def initialize(argv)
      @options = Options.new(argv)
    end

    def run
      reader = Reader.new(@options.notebook)
      if @options.read 
        reader.read
      end
      if @options.add  
        puts 'Enter new note title'
        title = gets.chomp
        puts 'Enter new note body'
        body = gets.chomp
        note = Note.new(title, body)
        note.write_to_file(@options.notebook)
      end
      if @options.edit
        reader.read
        if @options.edit_number >= NoteStore.instance.notebook_array.length
            puts "No note of that number; can't edit!"
            return
        end
        NoteStore.instance.edit(@options.edit_number)
        reader.write_all
      end
      if @options.all
        reader.read
        NoteStore.instance.do_to_all do |n|
            n.edit_title(@options.all_title)
        end
        reader.write_all
      end
    end
  end
end


